Codeforces Round #258 (Div. 2/C)/Codeforces451C_Predict Outcome of the Game(枚举)

解题报告

http://blog.csdn.net/juncoder/article/details/38102391

题意:

n场比赛其中k场是没看过的,对于这k场比赛,a,b,c三队赢的场次的关系是a队与b队的绝对值差d1,b队和c队绝对值差d2,求是否能使三支球队的赢的场次相同。

思路:

|B-A|=d1

|C-B|=d2

A+B+C=k

这样就有4种情况,分别是:

B>A&&C<B

B>A&&C>B

B<A&&C<B

B<A&&C>B

分别算出在k场比赛中a,b,c三支队伍赢的场次,另外n-k场比赛分别给3支队伍加上,看看是否能相同。

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#define LL long long
using namespace std;

int main()
{
    int t,i,j;
    while(~scanf("%d",&t))
    {
        while(t--)
        {
            LL d1,d2,n,k,a,b,c;
            scanf("%lld%lld%lld%lld",&n,&k,&d1,&d2);
            int f=0;
            LL kk=n/3;
            //1
            double fa=(double)((k+d2)-2*d1)/3;
            if(fa>=0&&fa==(LL )fa)
            {
                a=(LL)fa;
                b=d1+a;
                c=b-d2;
                if(a>=0&&b>=0&&c>=0&&b<=kk&&c<=kk&&a<=kk&&(kk-b+kk-a+kk-c)==(n-k))
                {
                    f=1;
                }
            }
            //2
            fa=(double)((k-d2)-2*d1)/3;
            if(fa>=0&&fa==(LL )fa)
            {
                a=(LL)fa;
                b=d1+a;
                c=b+d2;
                if(a>=0&&b>=0&&c>=0&&b<=kk&&c<=kk&&a<=kk&&(kk-b+kk-a+kk-c)==(n-k))
                {
                    f=1;
                }
            }
            //3
            fa=(double)((k+d2)+2*d1)/3;
            if(fa>=0&&fa==(LL )fa)
            {
                a=(LL )fa;
                b=a-d1;
                c=b-d2;
                if(a>=0&&b>=0&&c>=0&&b<=kk&&c<=kk&&a<=kk&&(kk-b+kk-a+kk-c)==(n-k))
                {
                    f=1;
                }
            }
            //4
            fa=(double)((k-d2)+2*d1)/3;
            if(fa>=0&&fa==(LL )fa)
            {
                a=(LL)fa;
                b=a-d1;
                c=b+d2;
                if(a>=0&&b>=0&&c>=0&&b<=kk&&c<=kk&&a<=kk&&(kk-b+kk-a+kk-c)==(n-k))
                {
                    f=1;
                }
            }
            if(f==1)
                printf("yes\n");
            else printf("no\n");
        }
    }
    return 0;
}

Predict Outcome of the Game

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

There are n games in a football tournament. Three teams are participating in it. Currently k games
had already been played.

You are an avid football fan, but recently you missed the whole k games. Fortunately, you remember a guess of your friend for these kgames.
Your friend did not tell exact number of wins of each team, instead he thought that absolute difference between number of wins of first and second team will be d1 and
that of between second and third team will be d2.

You don‘t want any of team win the tournament, that is each team should have the same number of wins after n games. That‘s why you want to know: does there
exist a valid tournament satisfying the friend‘s guess such that no team will win this tournament?

Note that outcome of a match can not be a draw, it has to be either win or loss.

Input

The first line of the input contains a single integer corresponding to number of test cases t (1?≤?t?≤?105).

Each of the next t lines will contain four space-separated integers n,?k,?d1,?d2 (1?≤?n?≤?1012; 0?≤?k?≤?n; 0?≤?d1,?d2?≤?k) —
data for the current test case.

Output

For each test case, output a single line containing either "yes" if it is possible to have no winner of tournament, or "no"
otherwise (without quotes).

Sample test(s)

input

5
3 0 0 0
3 3 0 0
6 4 1 0
6 3 3 0
3 3 3 2

output

yes
yes
yes
no
no

Note

Sample 1. There has not been any match up to now (k?=?0,?d1?=?0,?d2?=?0).
If there will be three matches (1-2, 2-3, 3-1) and each team wins once, then at the end each team will have 1 win.

Sample 2. You missed all the games (k?=?3). As d1?=?0 and d2?=?0,
and there is a way to play three games with no winner of tournament (described in the previous sample), the answer is "yes".

Sample 3. You missed 4 matches, and d1?=?1,?d2?=?0.
These four matches can be: 1-2 (win 2), 1-3 (win 3), 1-2 (win 1), 1-3 (win 1). Currently the first team has 2 wins, the second team has 1 win, the third team has 1 win. Two remaining matches can be: 1-2 (win 2), 1-3 (win 3). In the end all the teams have equal
number of wins (2 wins).

Codeforces Round #258 (Div. 2/C)/Codeforces451C_Predict Outcome of the Game(枚举)

时间: 2024-10-10 06:19:43

Codeforces Round #258 (Div. 2/C)/Codeforces451C_Predict Outcome of the Game(枚举)的相关文章

Codeforces Round #258 (Div. 2)

A - Game With Sticks 题目的意思: n个水平条,m个竖直条,组成网格,每次删除交点所在的行和列,两个人轮流删除,直到最后没有交点为止,最后不能再删除的人将输掉 解题思路: 每次删除交点所在的行和列,则剩下n-1行和m-1列,直到行或列被删完为止,最多删除的次数为min(n,m),删除min(n,m)后剩余的都是行或者列(注意行与行,列与列之间不可能有交点).只需要判断min(n,m)的奇偶性. #include <iostream> #include <vector&

Codeforces Round #258 (Div. 2)[ABCD]

Codeforces Round #258 (Div. 2)[ABCD] ACM 题目地址:Codeforces Round #258 (Div. 2) A - Game With Sticks 题意: Akshat and Malvika两人玩一个游戏,横竖n,m根木棒排成#型,每次取走一个交点,交点相关的横竖两条木棒要去掉,Akshat先手,给出n,m问谁赢. 分析: 水题,很明显不管拿掉哪个点剩下的都是(n-1,m-1),最后状态是(0,x)或(x,0),也就是拿了min(n,m)-1次,

Codeforces Round #258 (Div. 2)-(A,B,C,D,E)

http://blog.csdn.net/rowanhaoa/article/details/38116713 A:Game With Sticks 水题...每次操作,都会拿走一个横行,一个竖行. 所以一共会操作min(横行,竖行)次. #include<stdio.h> #include<iostream> #include<stdlib.h> #include<string.h> #include<algorithm> #include&l

Codeforces Round #258 (Div. 2) B. Sort the Array(简单题)

题目链接:http://codeforces.com/contest/451/problem/B ---------------------------------------------------------------------------------------------------------------------------------------------------------- 欢迎光临天资小屋:http://user.qzone.qq.com/593830943/ma

Codeforces Round #258 (Div. 2) A. Game With Sticks(数学题)

题目链接:http://codeforces.com/contest/451/problem/A ---------------------------------------------------------------------------------------------------------------------------------------------------------- 欢迎光临天资小屋:http://user.qzone.qq.com/593830943/ma

Codeforces Round #258 (Div. 2) 小结

A. Game With Sticks (451A) 水题一道,事实上无论你选取哪一个交叉点,结果都是行数列数都减一,那如今就是谁先减到行.列有一个为0,那么谁就赢了.因为Akshat先选,因此假设行列中最小的一个为奇数,那么Akshat赢,否则Malvika赢. 代码: #include <iostream> #include <cstdio> #include <cstring> #include <algorithm> using namespace

Codeforces Round #258 (Div. 2/A)/Codeforces451A_Game With Sticks

解题报告 http://blog.csdn.net/juncoder/article/details/38102263 n和m跟木棍相交,问一人取一交点(必须是交点,且取完后去掉交点的两根木棍),最后谁赢 思路: 取最大正方形,以对角线上的交点个数判断输赢. #include <iostream> #include <cstdio> using namespace std; int main() { int m,n; while(cin>>n>>m) { i

Codeforces Round #258 (Div. 2)Devu and Flowers 容斥原理

题目:Codeforces Round #258 (Div. 2)Devu and Flowers 题意:n个boxes ,第i个box有fi个flowers,每个boxes中的flowers完全相同,不同boxes的flowers不同,求从n个boxes中取出s个flowers的方案数.n<=20,s<=1e14,fi<=1e12. 排列组合的题目,一解法可用容斥原理(inclusion exclusion principle) . 有2中写法dfs和集合.下为集合写法. #inclu

Codeforces Round #262 (Div. 2) 460B. Little Dima and Equation(枚举)

题目链接:http://codeforces.com/problemset/problem/460/B B. Little Dima and Equation time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output Little Dima misbehaved during a math lesson a lot and the nas